# Stocks API

This module provides an API for retrieving financial and industry data for individual stocks and stock exchanges.

## Features

### Stock Exchange API

The module makes HTTP requests for data about various stock exchanges.
This data includes a list of stocks traded on an exchange, along with some basic industry and financial data for each stock on the exchange, parsed into a map.
Currently, only stocks listed on the New York Stock Exchange (NYSE) and NASDAQ are supported through the NASDAQ Exchange API implementation.

#### Usage

The NASDAQ Exchange API is a Drupal service that can be called from the server using drush or cron. The intention of this service is to be run periodicly to get the latest stocks on an exchange. Run functions in this service using drush, as follows:

`drush php-eval "<function_to_run>"`

### Stock Data API

This module makes HTTP requests for individual stock data. This data is returned as a JSON object and parsed into a map.
Currently, only the Alpha Vantage stock API is implemented for requesting data on individual stocks.
The requests to Alpha Vantage require an API key, which must be generated from the Alpha Vantage website (https://www.alphavantage.co/).
The API key should then be stored on the server and referenced from settings, for security purposes, in the "alpha_vantage_api_key" setting in settings.php.

#### Usage

The Alpha Vangtage Stock API is a Drupal service that can be called from the server using drush or cron. The intention of this service is to be run periodicly to get the latest stock data. Run functions in this service using drush, as follows:

`drush php-eval "<function_to_run>"`

### Extensibility

The module supports scalability to other stock data services through class interfaces.

### Future Development

A configuration form (StocksAPISettingsForm) has been added to support saving configuration for common uses of stock data. This configuration form does not currently make use of the saved values. In future versions of the Stocks API module, we will look to make use of the configuration form.

## Testing

This module has not been tested for production environments.

## Contributors

* **Omar Abed** (@omarabed)
* **Malik Kotob** (@malikkotob) - Drupal 8 Grandmaster

## Acknowledgments

Big thanks to @malikkotob for extensive guidance throughout the development of this module.
